/*=============================================================================
	UnXC_Game.h: Unreal game class.
=============================================================================*/

/*-----------------------------------------------------------------------------
	Unreal game engine.
-----------------------------------------------------------------------------*/
#if _MSC_VER
#pragma pack (push,4)
#endif

#ifndef XC_ENGINE_API
#define XC_ENGINE_API DLL_IMPORT
#endif

#ifndef NAMES_ONLY
#define AUTOGENERATE_NAME(name) extern XC_ENGINE_API FName XC_ENGINE_##name;
#define AUTOGENERATE_FUNCTION(cls,idx,name)
#endif

AUTOGENERATE_NAME(XC_Engine)
AUTOGENERATE_NAME(XC_GameEngine)
AUTOGENERATE_NAME(XC_ConnectionHandler)

#ifndef NAMES_ONLY

//Do remove debugging instructions
//#define CACUS_DEBUG

#include "XC_CoreObj.h"

//These variables should persist, so we can't really afford to let the garbage collector to mess this up

#ifndef DISABLE_COLLISION
	XC_ENGINE_API extern FCollisionCacus*	CollisionCacus;
#endif

#ifndef DISABLE_SCRIPT
class AXC_DummyPawn : public APawn
{
	friend class UXC_GameEngine;
	
	public:
	DECLARE_FUNCTION(NewMapName);			//539 - hack
	DECLARE_FUNCTION(NewPlayerCanSeeMe);		//532 - hack
	DECLARE_FUNCTION(NewDynArrayElement);		//10 - hack, version 10
	DECLARE_FUNCTION(NewDynArrayLength);		//640 - version 10
	DECLARE_FUNCTION(NewDynArrayInsert);		//641 - version 10
	DECLARE_FUNCTION(NewDynArrayRemove);		//642 - version 10
	DECLARE_FUNCTION(execAddToPackagesMap);		//1718 - version 11
	DECLARE_FUNCTION(execIsInPackageMap);		//1719 - version 13
	DECLARE_FUNCTION(PreLoginNative);		//3550 - internal
	DECLARE_FUNCTION(AdminLoginNative);		//3551 - internal
	DECLARE_FUNCTION(execCollidingActors);		//3552 - version 12
	DECLARE_FUNCTION(NewVirtualFunction);		//EX_VirtualFunction
	DECLARE_FUNCTION(PlayerSpeechNative);		//Direct binding - version 17
};
#endif

//
// Editor entry point
//
class XC_ENGINE_API UXC_EditorLoader : public UObject
{
	public:
	DECLARE_CLASS(UXC_EditorLoader,UObject,0,XC_Engine)
};


//
// The Unreal game engine, subclassed.
//

struct FGameLevelHeader
{
	ULevel* GLevel;
	ULevel* GEntry;
	UPendingLevel* GPendingLevel;
	FURL			LastURL;
	TArray<FString> ServerActors;
	TArray<FString> ServerPackages;
};


#define XCGE_Defaults GetDefault<UXC_GameEngine>()
class XC_ENGINE_API UXC_GameEngine : public UGameEngine
{
	#include "UXC_GameEngine.h"
};



#endif

#ifndef NAMES_ONLY
#undef AUTOGENERATE_NAME
#undef AUTOGENERATE_FUNCTION
#endif NAMES_ONLY

#if _MSC_VER
#pragma pack (pop)
#endif

/*-----------------------------------------------------------------------------
	The End.
-----------------------------------------------------------------------------*/
